#!/bin/bash
# reads buttons.css and if blank writes default colors to buttons.css (for defaults make buttons.css blank)
# plural is unhovered, singular is hovered
bm_on=$(awk '/'on{back'/' /root/.bookmarks/bm/css/buttons.css | sed 's/.on{background-color://' | sed 's/}//');if [[ $bm_on = \# ]]; then bm_on=$(echo "#1e90ff"); fi
bm_off=$(awk '/'off\ a{back'/' /root/.bookmarks/bm/css/buttons.css | sed 's/.off\ a{background-color://' | sed 's/}//');if [[ $bm_off = \# ]]; then bm_off=$(echo "#8fbc8f"); fi
bm_links=$(awk '/'3\)\ a{back'/' /root/.bookmarks/bm/css/buttons.css | sed 's/td:nth-of-type(2) a,td:nth-of-type(3) a{background-color://' | sed 's/}//');if [[ $bm_links = \# ]]; then bm_links=$(echo "#d5c9b9"); fi
bm_link=$(awk '/'3\)\ a:hover{back'/' /root/.bookmarks/bm/css/buttons.css | sed 's/td:nth-of-type(2) a:hover,td:nth-of-type(3) a:hover{background-color://' | sed 's/}//');if [[ $bm_link = \# ]]; then bm_link=$(echo "#ffff00"); fi
bm_tags=$(awk '/'a:active{back'/' /root/.bookmarks/bm/css/buttons.css | sed 's/.tag a:link,.tag a:visited,.tag a:active{background-color://' | sed 's/}//');if [[ $bm_tags = \# ]]; then bm_tags=$(echo "#d5c9b9"); fi
bm_tag=$(awk '/'tag\ a:hover{back'/' /root/.bookmarks/bm/css/buttons.css | sed 's/.tag a:hover{background-color://' | sed 's/}//');if [[ $bm_tag = \# ]]; then bm_tag=$(echo "#08f5e0"); fi
bm_texts=$(awk '/'3\)\ a{color'/' /root/.bookmarks/bm/css/buttons.css | sed 's/td:nth-of-type(2) a,td:nth-of-type(3) a{color://' | sed 's/}//');if [[ $bm_texts = \# ]]; then bm_texts=$(echo "#003366"); fi
bm_text=$(awk '/'hover{color'/' /root/.bookmarks/bm/css/buttons.css | sed 's/td:nth-of-type(2) a:hover,td:nth-of-type(3) a:hover{color://' | sed 's/}//');if [[ $bm_text = \# ]]; then bm_text=$(echo "#003366"); fi

echo $bm_on
echo $bm_off
echo $bm_links
echo $bm_link
echo $bm_tags
echo $bm_tag
echo $bm_texts
echo $bm_text

# dialog to change colors
dialog=$(yad --title "Buttons" --width=230 --mouse \
--form --text=" 32x32 favicon.ico" \
--field=ON:CLR $bm_on \
--field=OFF:CLR $bm_off \
--field=links:CLR $bm_links \
--field=LINK:CLR $bm_link \
--field=tags:CLR $bm_tags \
--field=TAG:CLR $bm_tag \
--field=texts:CLR $bm_texts \
--field=TEXT:CLR $bm_text \
--button="Backup:2" --button="gtk-ok:0")
ret=$?
if [[ $ret -eq 2 ]]; then
cp /root/.bookmarks/bm/css/buttons.css /root/.bookmarks/bm/css/buttons.css.bak;
fi

ON=$(echo $dialog | awk 'BEGIN {FS="|" }{print $1}')
OFF=$(echo $dialog | awk 'BEGIN {FS="|" }{print $2}')
links=$(echo $dialog | awk 'BEGIN {FS="|" }{print $3}')
LINK=$(echo $dialog | awk 'BEGIN {FS="|" }{print $4}')
tags=$(echo $dialog | awk 'BEGIN {FS="|" }{print $5}')
TAG=$(echo $dialog | awk 'BEGIN {FS="|" }{print $6}')
texts=$(echo $dialog | awk 'BEGIN {FS="|" }{print $7}')
TEXT=$(echo $dialog | awk 'BEGIN {FS="|" }{print $8}')

red1=${ON:1:2}
green1=${ON:5:2}
blue1=${ON:9:2}
on="#"$red1$green1$blue1

red2=${OFF:1:2}
green2=${OFF:5:2}
blue2=${OFF:9:2}
off="#"$red2$green2$blue2

red3=${links:1:2}
green3=${links:5:2}
blue3=${links:9:2}
links="#"$red3$green3$blue3

red4=${LINK:1:2}
green4=${LINK:5:2}
blue4=${LINK:9:2}
link="#"$red4$green4$blue4

red5=${tags:1:2}
green5=${tags:5:2}
blue5=${tags:9:2}
tags="#"$red5$green5$blue5

red6=${TAG:1:2}
green6=${TAG:5:2}
blue6=${TAG:9:2}
tag="#"$red6$green6$blue6

red7=${texts:1:2}
green7=${texts:5:2}
blue7=${texts:9:2}
texts="#"$red7$green7$blue7

red8=${TEXT:1:2}
green8=${TEXT:5:2}
blue8=${TEXT:9:2}
text="#"$red8$green8$blue8

if [[ $on = \# ]];then on=$(echo "#1e90ff");fi
if [[ $off = \# ]];then off=$(echo "#8fbc8f");fi
if [[ $links = \# ]];then links=$(echo "#d5c9b9");fi
if [[ $link = \# ]];then link=$(echo "#ffff00");fi
if [[ $tags = \# ]];then tags=$(echo "#d5c9b9");fi
if [[ $tag = \# ]];then tag=$(echo "#08f5e0");fi
if [[ $texts = \# ]];then texts=$(echo "#003366");fi
if [[ $text = \# ]];then text=$(echo "#003366");fi

printf ".on{background-color:$on}
.off a{background-color:$off}
td:nth-of-type(2) a,td:nth-of-type(3) a{background-color:$links}
td:nth-of-type(2) a:hover,td:nth-of-type(3) a:hover{background-color:$link}
.tag a:link,.tag a:visited,.tag a:active{background-color:$tags}
.tag a:hover{background-color:$tag}
td:nth-of-type(2) a,td:nth-of-type(3) a{color:$texts}
td:nth-of-type(2) a:hover,td:nth-of-type(3) a:hover{color:$text}" > /root/.bookmarks/bm/css/buttons.css
